var colInfos = [
  { name: "name", displayName: "Name", size: 100 },
  { name: "id", displayName: "ID", size: 110 },
  { name: "color", displayName: "Color" },
  { name: "price", displayName: "Price", formatter: "0.00", size: 80 },
  { name: "Ratio", displayName: "Ratio", formatter: "0.00%", size: 80 },
];

window.onload = function () {
  var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), {
    sheetCount: 1,
  });
  initSpread(spread);

  // 方案一
  document.getElementById("setData").onclick = function () {
    let sheet = spread.getSheet(0),
      sheetData = getProducts2();
    sheet.getRange(0, 0, sheet.getRowCount(), sheet.getColumnCount()).textIndent(null);
    sheet.outlineColumn.refresh();
    sheet.setDataSource(sheetData);
    toInitOutlineColumn(sheet, sheetData);
  };

  // 方案二
  document.getElementById("setData").onclick = function () {
    let sheet = spread.getSheet(0),
      sheetData = getProducts2();
    sheet.setDataSource(sheetData, true);
    sheet.bindColumns(colInfos);
    toInitOutlineColumn(sheet, sheetData);
  };
};

function getProducts2() {
  return [
    {
      id: 1,
      name: "父级1",
      Ratio: 0.92,
      level: 0,
    },
    {
      id: 2,
      name: "子级11",
      Ratio: 0.6,
      level: 1,
    },
    {
      id: 3,
      name: "父级2",
      Ratio: 0.31,
      level: 0,
    },
    {
      id: 4,
      name: "子级21",
      Ratio: 0.7,
      level: 1,
    },
  ];
}

function getProducts() {
  return [
    {
      id: 1,
      name: "父级1",
      Ratio: 0.92,
      level: 0,
    },
    {
      id: 2,
      name: "子级11",
      Ratio: 0.6,
      level: 1,
    },
    {
      id: 3,
      name: "子级12",
      Ratio: 0.31,
      level: 1,
    },
    {
      id: 4,
      name: "父级2",
      Ratio: 0.26,
      level: 0,
    },
    {
      id: 5,
      name: "子级21",
      Ratio: 0.31,
      level: 1,
    },
  ];
}

function initSpread(spread) {
  spread.suspendPaint();

  var sheet = spread.getSheet(0);
  sheet.name("Custom binding");
  sheet.autoGenerateColumns = false;

  const sheetData = getProducts();

  sheet.setDataSource(sheetData);

  sheet.bindColumns(colInfos);

  toInitOutlineColumn(sheet, sheetData);

  spread.resumePaint();
}

function toInitOutlineColumn(sheet, sheetData) {
  for (let r = 0; r < sheetData?.length; r++) {
    sheet?.getCell(r, 0).textIndent(sheetData[r].level);
  }
  sheet.outlineColumn.options({
    columnIndex: 0,
    showImage: false,
    showCheckBox: false,
    maxLevel: 100,
  });
  sheet.showRowOutline(false);
  sheet.outlineColumn.refresh();
}
